<!DOCTYPE html>

<html lang="en" data-content_root="./">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>birdshot &#8212; birdshot 0.0.post1.dev20+g168d24e.d20231220 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="_static/alabaster.css?v=233b9934" />
    <script src="_static/documentation_options.js?v=c5a7b33d"></script>
    <script src="_static/doctools.js?v=888ff710"></script>
    <script src="_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Contributing" href="contributing.html" />
    <link rel="prev" title="birdshot" href="readme.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="birdshot">
<h1>birdshot<a class="headerlink" href="#birdshot" title="Link to this heading">¶</a></h1>
<p>BIRDSHOT object manipulation.</p>
<p>This CLI allows users to read, write, and manipulate data stored in the
BIRDSHOT project Google Drive from the command line.</p>
<p>Logging can be enabled by setting DEBUG, INFO, WARNING, or ERROR
environment variables.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span><span class="w"> </span>COMMAND1<span class="w"> </span><span class="o">[</span>ARGS<span class="o">]</span>...<span class="w"> </span><span class="o">[</span>COMMAND2<span class="w"> </span><span class="o">[</span>ARGS<span class="o">]</span>...<span class="o">]</span>...
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-no-auth">
<span class="sig-name descname"><span class="pre">--no-auth</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-no-auth" title="Link to this definition">¶</a></dt>
<dd><p>If a command chain does not require authentication, authenticate with Carta may be skipped.</p>
<dl class="field-list simple">
<dt class="field-odd">Default<span class="colon">:</span></dt>
<dd class="field-odd"><p><code class="docutils literal notranslate"><span class="pre">False</span></code></p>
</dd>
</dl>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-u">
<span id="cmdoption-birdshot-username"></span><span class="sig-name descname"><span class="pre">-u</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--username</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;username&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-u" title="Link to this definition">¶</a></dt>
<dd><p>Carta username. Default: looks for the username in the CARTA_USER environment variable.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-p">
<span id="cmdoption-birdshot-password"></span><span class="sig-name descname"><span class="pre">-p</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--password</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;password&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-p" title="Link to this definition">¶</a></dt>
<dd><p>Carta password. Default: Looks for the password in the CARTA_PASS environment variable.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-url">
<span class="sig-name descname"><span class="pre">--url</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;url&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-url" title="Link to this definition">¶</a></dt>
<dd><p>Development Only. Base URL of the Carta API.</p>
<dl class="field-list simple">
<dt class="field-odd">Options<span class="colon">:</span></dt>
<dd class="field-odd"><p><a class="reference external" href="https://api.carta.contextualize.us.com">https://api.carta.contextualize.us.com</a> | <a class="reference external" href="https://api.sandbox.carta.contextualize.us.com">https://api.sandbox.carta.contextualize.us.com</a></p>
</dd>
</dl>
</dd></dl>

<section id="birdshot-aggregate">
<h2>aggregate<a class="headerlink" href="#birdshot-aggregate" title="Link to this heading">¶</a></h2>
<p>Aggregate data from the leaf node toward the root. (Data flow:
successor -&gt; predecessor.) This is done in place.</p>
<p>Two algorithms are available: postorder (default) and preorder. In
postorder traveral properties are passed from leaf nodes through to all
predecessors (collect). In preorder traversal, properties are passed
only to the immediate predecessor of each node (nearest).</p>
<p>If there is no path to a root node from a leaf, the leaf’s properties are
aggregated to its root, even if that root does not match “start”.</p>
<p>This operation does not consume any objects. All objects are returned to
the stream once the aggregation is complete. This operation only acts upon
directed graphs.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>aggregate<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-aggregate-algorithm">
<span class="sig-name descname"><span class="pre">--algorithm</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;algorithm&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-aggregate-algorithm" title="Link to this definition">¶</a></dt>
<dd><p>Order in which nodes are visited.</p>
<dl class="field-list simple">
<dt class="field-odd">Options<span class="colon">:</span></dt>
<dd class="field-odd"><p>preorder | nearest | postorder | collect</p>
</dd>
</dl>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-aggregate-method">
<span class="sig-name descname"><span class="pre">--method</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;method&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-aggregate-method" title="Link to this definition">¶</a></dt>
<dd><p>How to combine properties; either ‘skip’ if property already exists or ‘append’.</p>
<dl class="field-list simple">
<dt class="field-odd">Options<span class="colon">:</span></dt>
<dd class="field-odd"><p>skip | append</p>
</dd>
</dl>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-aggregate-start">
<span class="sig-name descname"><span class="pre">--start</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;start&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-aggregate-start" title="Link to this definition">¶</a></dt>
<dd><p>Select the node(s) from which to start the aggregation. Default: all leaf nodes. Only the ‘postorder’ algorithm is available if ‘start’ is specified.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-aggregate-stop">
<span class="sig-name descname"><span class="pre">--stop</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;stop&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-aggregate-stop" title="Link to this definition">¶</a></dt>
<dd><p>Select the node(s) that signal the end of the aggregation. Default: the root(s).</p>
</dd></dl>

</section>
<section id="birdshot-all">
<h2>all<a class="headerlink" href="#birdshot-all" title="Link to this heading">¶</a></h2>
<p>Returns True if all enqueued values are True.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>all<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-any">
<h2>any<a class="headerlink" href="#birdshot-any" title="Link to this heading">¶</a></h2>
<p>Returns True if any enqueued value is True.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>any<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-apply">
<h2>apply<a class="headerlink" href="#birdshot-apply" title="Link to this heading">¶</a></h2>
<p>For each iterable-like entry in the stream, apply the named function to
each element in that iterable.</p>
<p>Function parameters must be passed through the <cite>params</cite> option. The
required arguments to each function can be found in the “help” of the
function.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>apply<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span><span class="w"> </span>FUNC
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-apply-p">
<span id="cmdoption-birdshot-apply-params"></span><span class="sig-name descname"><span class="pre">-p</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--params</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;params&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-apply-p" title="Link to this definition">¶</a></dt>
<dd><p>String of function options in the format ‘param1=value1|param2=value2|…’.</p>
</dd></dl>

<p class="rubric">Arguments</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-apply-arg-FUNC">
<span class="sig-name descname"><span class="pre">FUNC</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-apply-arg-FUNC" title="Link to this definition">¶</a></dt>
<dd><p>Required argument</p>
</dd></dl>

</section>
<section id="birdshot-bool">
<h2>bool<a class="headerlink" href="#birdshot-bool" title="Link to this heading">¶</a></h2>
<p>Cast each object as a boolean.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>bool<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-children">
<h2>children<a class="headerlink" href="#birdshot-children" title="Link to this heading">¶</a></h2>
<p>Return the children nodes of each Birdshot.Entry node.</p>
<p>If none, returns an empty list.</p>
<p>Warning: All non-node objects are discarded.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>children<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-children-graph">
<span class="sig-name descname"><span class="pre">--graph</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;graph&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-children-graph" title="Link to this definition">¶</a></dt>
<dd><p>Use a stored graph.</p>
</dd></dl>

</section>
<section id="birdshot-dict">
<h2>dict<a class="headerlink" href="#birdshot-dict" title="Link to this heading">¶</a></h2>
<p>Typically used in conjunction with <cite>pop –zip</cite>, this generates a dictionary
from a list of tuples.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>dict<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-download">
<h2>download<a class="headerlink" href="#birdshot-download" title="Link to this heading">¶</a></h2>
<p>Download the files associated with the Birdshot.Entry nodes.</p>
<p>If specified, a FILENAME may be provided as a default. If not specified the
files are saved to &lt;node.name&gt;-&lt;node.id&gt;.&lt;node.suffix&gt;. For example, for a
node named “foo.txt” with id = “1234”, the file will be saved to
“foo-1234.txt”.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>download<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span><span class="w"> </span><span class="o">[</span>FILENAME<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-download-d">
<span id="cmdoption-birdshot-download-dest"></span><span class="sig-name descname"><span class="pre">-d</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--dest</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;dest&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-download-d" title="Link to this definition">¶</a></dt>
<dd><p>Directory where the downloaded file(s) should be stored.</p>
</dd></dl>

<p class="rubric">Arguments</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-download-arg-FILENAME">
<span class="sig-name descname"><span class="pre">FILENAME</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-download-arg-FILENAME" title="Link to this definition">¶</a></dt>
<dd><p>Optional argument</p>
</dd></dl>

</section>
<section id="birdshot-drop">
<h2>drop<a class="headerlink" href="#birdshot-drop" title="Link to this heading">¶</a></h2>
<p>Drop all objects from the queue.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>drop<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-dump">
<h2>dump<a class="headerlink" href="#birdshot-dump" title="Link to this heading">¶</a></h2>
<p>Dumps the objects in the queue to archives. This attempts to write first to
the more restrictive, but more ubiquitous, JSON archive and, if that fails,
to the more general python pickle archive.</p>
<p>Objects are consumed on dump, so if you wish to continue working on working
with objects after they are saved, be sure to save them (push/pop) before
writing.</p>
<p>## JSON Parameters</p>
<div class="line-block">
<div class="line">skipkeys=False,</div>
<div class="line">ensure_ascii=True,</div>
<div class="line">check_circular=True,</div>
<div class="line">allow_nan=True,</div>
<div class="line">cls=None,</div>
<div class="line">indent=None,</div>
<div class="line">separators=None,</div>
<div class="line">default=None,</div>
<div class="line">sort_keys=False</div>
</div>
<p>## Pickle Parameters</p>
<div class="line-block">
<div class="line">protocol=None,</div>
<div class="line">fix_imports=True,</div>
<div class="line">buffer_callback=None,</div>
</div>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>dump<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span><span class="w"> </span>PREFIX
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-dump-error">
<span class="sig-name descname"><span class="pre">--error</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;error&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-dump-error" title="Link to this definition">¶</a></dt>
<dd><p>Exit, pass, or skip files that fail.</p>
<dl class="field-list simple">
<dt class="field-odd">Options<span class="colon">:</span></dt>
<dd class="field-odd"><p>exit | stop | skip</p>
</dd>
</dl>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-dump-p">
<span id="cmdoption-birdshot-dump-params"></span><span class="sig-name descname"><span class="pre">-p</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--params</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;params&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-dump-p" title="Link to this definition">¶</a></dt>
<dd><p>String of function options in the format ‘param1=value1|param2=value2|…’.</p>
</dd></dl>

<p class="rubric">Arguments</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-dump-arg-PREFIX">
<span class="sig-name descname"><span class="pre">PREFIX</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-dump-arg-PREFIX" title="Link to this definition">¶</a></dt>
<dd><p>Required argument</p>
</dd></dl>

</section>
<section id="birdshot-dumps">
<h2>dumps<a class="headerlink" href="#birdshot-dumps" title="Link to this heading">¶</a></h2>
<p>Dumps the objects to the stdout in JSON format.</p>
<p>## Parameters</p>
<div class="line-block">
<div class="line">skipkeys=False,</div>
<div class="line">ensure_ascii=True,</div>
<div class="line">check_circular=True,</div>
<div class="line">allow_nan=True,</div>
<div class="line">cls=None,</div>
<div class="line">indent=None,</div>
<div class="line">separators=None,</div>
<div class="line">default=None,</div>
<div class="line">sort_keys=False</div>
</div>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>dumps<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-dumps-error">
<span class="sig-name descname"><span class="pre">--error</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;error&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-dumps-error" title="Link to this definition">¶</a></dt>
<dd><p>Exit, pass, or skip files that fail.</p>
<dl class="field-list simple">
<dt class="field-odd">Options<span class="colon">:</span></dt>
<dd class="field-odd"><p>exit | stop | skip</p>
</dd>
</dl>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-dumps-p">
<span id="cmdoption-birdshot-dumps-params"></span><span class="sig-name descname"><span class="pre">-p</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--params</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;params&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-dumps-p" title="Link to this definition">¶</a></dt>
<dd><p>String of function options in the format ‘param1=value1|param2=value2|…’.</p>
</dd></dl>

</section>
<section id="birdshot-field">
<h2>field<a class="headerlink" href="#birdshot-field" title="Link to this heading">¶</a></h2>
<p>Extracts a field (obj.&lt;FIELD&gt;) from each object in the stream.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>field<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span><span class="w"> </span>FIELD
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-field-m">
<span id="cmdoption-birdshot-field-missing"></span><span class="sig-name descname"><span class="pre">-m</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--missing</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;missing&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-field-m" title="Link to this definition">¶</a></dt>
<dd><p>Action for objects lacking the requested field: {exit|pass|skip|stop|&lt;default&gt;}.</p>
</dd></dl>

<p class="rubric">Arguments</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-field-arg-FIELD">
<span class="sig-name descname"><span class="pre">FIELD</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-field-arg-FIELD" title="Link to this definition">¶</a></dt>
<dd><p>Required argument</p>
</dd></dl>

</section>
<section id="birdshot-get">
<h2>get<a class="headerlink" href="#birdshot-get" title="Link to this heading">¶</a></h2>
<p>Extracts a key (obj[&lt;KEY&gt;]) from each object in the stream.</p>
<p>If not one of {exit, pass, skip, or stop}, a literal evaluation of the
value is passed as the default, e.g. ‘–missing None’</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>get<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-get-k">
<span id="cmdoption-birdshot-get-key"></span><span class="sig-name descname"><span class="pre">-k</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--key</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;key&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-get-k" title="Link to this definition">¶</a></dt>
<dd><p>Dict key to access.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-get-i">
<span id="cmdoption-birdshot-get-index"></span><span class="sig-name descname"><span class="pre">-i</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--index</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;index&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-get-i" title="Link to this definition">¶</a></dt>
<dd><p>List index to access.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-get-m">
<span id="cmdoption-birdshot-get-missing"></span><span class="sig-name descname"><span class="pre">-m</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--missing</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;missing&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-get-m" title="Link to this definition">¶</a></dt>
<dd><p>Action {exit|pass|skip|stop} or default value for objects lacking the requested field.</p>
</dd></dl>

</section>
<section id="birdshot-graph">
<h2>graph<a class="headerlink" href="#birdshot-graph" title="Link to this heading">¶</a></h2>
<p>Returns, and if necessary constructs from Google Drive, a graph of the
BIRDSHOT data/filesystem.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>graph<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-iter">
<h2>iter<a class="headerlink" href="#birdshot-iter" title="Link to this heading">¶</a></h2>
<p>Iterates through stream objects that are iterable. Stream objects that are
not iterable are passed through unaltered.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>iter<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-len">
<h2>len<a class="headerlink" href="#birdshot-len" title="Link to this heading">¶</a></h2>
<p>Writes the length of the stream to the stdout.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>len<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-list">
<h2>list<a class="headerlink" href="#birdshot-list" title="Link to this heading">¶</a></h2>
<p>Convert the stream into a list.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>list<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-load">
<h2>load<a class="headerlink" href="#birdshot-load" title="Link to this heading">¶</a></h2>
<p>Loads either a JSON or python pickle archive, based on the filename prefix.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>load<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span><span class="w"> </span>INPUT
</pre></div>
</div>
<p class="rubric">Arguments</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-load-arg-INPUT">
<span class="sig-name descname"><span class="pre">INPUT</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-load-arg-INPUT" title="Link to this definition">¶</a></dt>
<dd><p>Required argument</p>
</dd></dl>

</section>
<section id="birdshot-model-dump">
<h2>model-dump<a class="headerlink" href="#birdshot-model-dump" title="Link to this heading">¶</a></h2>
<p>Converts pydantic BaseModel-like objects to JSON. Other objects are
returned unaltered.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>model-dump<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-node-filter">
<h2>node-filter<a class="headerlink" href="#birdshot-node-filter" title="Link to this heading">¶</a></h2>
<p>Search the BIRDSHOT Google Drive for entries matching the specified
pattern. All patterns are interpreted as regular expressions.</p>
<p>If multiple patterns are specified, the results are logically OR’ed. For
example:</p>
<div class="line-block">
<div class="line">birdshot graph nodes </div>
<div class="line-block">
<div class="line">iter </div>
<div class="line">filter-records -n “.*.json” -“.*.txt” </div>
<div class="line">filter-records -n “foo.*”</div>
</div>
</div>
<p>will return all records matching (‘.*.json’ or ‘.*.txt’) and (‘foo.*’),
i.e. any records with names matching ‘foo.*.(json|txt)’.</p>
<p>That is, arguments within a single filter command ‘OR’, subsequent filter
commands ‘AND’.</p>
<p>All objects that are not records are dropped.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>node-filter<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-node-filter-id">
<span class="sig-name descname"><span class="pre">--id</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;id&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-node-filter-id" title="Link to this definition">¶</a></dt>
<dd><p>Search records for matching ID.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-node-filter-n">
<span id="cmdoption-birdshot-node-filter-name"></span><span class="sig-name descname"><span class="pre">-n</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--name</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;name&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-node-filter-n" title="Link to this definition">¶</a></dt>
<dd><p>Search for records with matching name.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-node-filter-default">
<span class="sig-name descname"><span class="pre">--default</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;default&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-node-filter-default" title="Link to this definition">¶</a></dt>
<dd><p>Provides a default for objects that do not match or are not valid nodes.</p>
</dd></dl>

</section>
<section id="birdshot-nodes">
<h2>nodes<a class="headerlink" href="#birdshot-nodes" title="Link to this heading">¶</a></h2>
<p>Accesses the nodes from a stream.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>nodes<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-parents">
<h2>parents<a class="headerlink" href="#birdshot-parents" title="Link to this heading">¶</a></h2>
<p>Returns the parent folder(s) of each Birdshot.Entry node.</p>
<p>If no parents are present, an empty list is returned.</p>
<p>Note: Non-node entries in the stream are discarded.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>parents<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-parents-graph">
<span class="sig-name descname"><span class="pre">--graph</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;graph&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-parents-graph" title="Link to this definition">¶</a></dt>
<dd><p>Use a stored graph.</p>
</dd></dl>

</section>
<section id="birdshot-path">
<h2>path<a class="headerlink" href="#birdshot-path" title="Link to this heading">¶</a></h2>
<p>Returns the path to each Birdshot.Entry record. Multiple paths are not
supported.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>path<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-path-g">
<span id="cmdoption-birdshot-path-graph"></span><span class="sig-name descname"><span class="pre">-g</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--graph</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;graph&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-path-g" title="Link to this definition">¶</a></dt>
<dd><p>Key to access the previously stored graph.</p>
</dd></dl>

</section>
<section id="birdshot-pop">
<h2>pop<a class="headerlink" href="#birdshot-pop" title="Link to this heading">¶</a></h2>
<p>Adds the last set of objects pushed onto the stack. This is used in
conjunction with <cite>push</cite> to temporarily store data for later processing.</p>
<p>By default, the existing arguments are returned before the arguments popped
from the stack. This can be reversed using the ‘-r/–reverse’ flag.</p>
<p>Existing and stack arguments can be zipped together (‘-z/–zip’ flag).
Multiple calls to <cite>pop</cite> with construct an increasingly large tuple. For
example:</p>
<dl class="option-list">
<dt><kbd><span class="option">/b</span></kbd></dt>
<dd><dl class="simple">
<dt>birdshot graph # gets the BIRDSHOT graph</dt><dd><p>field nodes # gets the graph nodes iterator object
iter # iterates through the nodes
push –pass # pushes the nodes onto the stack for now and later
field name # gets the name field from each node
push # stores names in the stack for later
pop –index 0 # pops the nodes off the stack
field id # gets the id field from each node
pop –zip # zips id and name into  (id, name) pairs.</p>
</dd>
</dl>
</dd>
</dl>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>pop<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-pop-i">
<span id="cmdoption-birdshot-pop-index"></span><span class="sig-name descname"><span class="pre">-i</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--index</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;index&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-pop-i" title="Link to this definition">¶</a></dt>
<dd><p>Index of the results to inject. Default: -1 (last <a href="#id1"><span class="problematic" id="id2">`</span></a>push`ed).</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-pop-z">
<span id="cmdoption-birdshot-pop-zip"></span><span class="sig-name descname"><span class="pre">-z</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--zip</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-pop-z" title="Link to this definition">¶</a></dt>
<dd><p><cite>zip</cite> stack contents (S) with existing arguments (A) into (a, s).</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-pop-r">
<span id="cmdoption-birdshot-pop-reverse"></span><span class="sig-name descname"><span class="pre">-r</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--reverse</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-pop-r" title="Link to this definition">¶</a></dt>
<dd><p>Reverse the order of the stack (S) and existing arguments (A). Default: A then S.</p>
</dd></dl>

</section>
<section id="birdshot-propagate">
<h2>propagate<a class="headerlink" href="#birdshot-propagate" title="Link to this heading">¶</a></h2>
<p>Propagates data towards leaf nodes. (Data flow: predecessor -&gt; successor.)
This is done in place.</p>
<p>Two algorithms are available: preorder (default) and postorder. In preorder
traveral properties are passed from root node through to all descendents
(scatter). In postodrer traversal, properties are passed only to the
immediate successor of each node (nearest).</p>
<p>If there is no path to a leaf node from a root, the root’s properties are
propagated to the terminal nodes.</p>
<p>This operation does not consume any objects. All objects are returned to
the stream once the aggregation is complete. This operation only acts upon
directed graphs.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>propagate<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-propagate-algorithm">
<span class="sig-name descname"><span class="pre">--algorithm</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;algorithm&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-propagate-algorithm" title="Link to this definition">¶</a></dt>
<dd><p>Order in which nodes are visited.</p>
<dl class="field-list simple">
<dt class="field-odd">Default<span class="colon">:</span></dt>
<dd class="field-odd"><p><code class="docutils literal notranslate"><span class="pre">scatter</span></code></p>
</dd>
<dt class="field-even">Options<span class="colon">:</span></dt>
<dd class="field-even"><p>preorder | scatter | postorder | nearest</p>
</dd>
</dl>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-propagate-method">
<span class="sig-name descname"><span class="pre">--method</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;method&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-propagate-method" title="Link to this definition">¶</a></dt>
<dd><p>How to combine properties; either ‘skip’ if property already exists or ‘append’.</p>
<dl class="field-list simple">
<dt class="field-odd">Default<span class="colon">:</span></dt>
<dd class="field-odd"><p><code class="docutils literal notranslate"><span class="pre">append</span></code></p>
</dd>
<dt class="field-even">Options<span class="colon">:</span></dt>
<dd class="field-even"><p>skip | append</p>
</dd>
</dl>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-propagate-start">
<span class="sig-name descname"><span class="pre">--start</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;start&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-propagate-start" title="Link to this definition">¶</a></dt>
<dd><p>Select the node(s) from which to start the propagation. Default: all root nodes. Only the ‘preorder’ algorithm is available if ‘start’ is specified.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-propagate-stop">
<span class="sig-name descname"><span class="pre">--stop</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;stop&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-propagate-stop" title="Link to this definition">¶</a></dt>
<dd><p>Select the node(s) that signal the end of the aggregation. Default: the leaf node(s).</p>
</dd></dl>

</section>
<section id="birdshot-push">
<h2>push<a class="headerlink" href="#birdshot-push" title="Link to this heading">¶</a></h2>
<p>Pushes the objects onto the stack for future use.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>push<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-push-pass">
<span class="sig-name descname"><span class="pre">--pass</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-push-pass" title="Link to this definition">¶</a></dt>
<dd><p>If set, the current stream will be stashed but also continue through the pipeline.</p>
</dd></dl>

</section>
<section id="birdshot-reduce">
<h2>reduce<a class="headerlink" href="#birdshot-reduce" title="Link to this heading">¶</a></h2>
<p>Perform one or more reductions on node properties.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>reduce<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-reduce-c">
<span id="cmdoption-birdshot-reduce-cast"></span><span class="sig-name descname"><span class="pre">-c</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--cast</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;cast&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-reduce-c" title="Link to this definition">¶</a></dt>
<dd><p>Cast values before performing the reduction.</p>
<dl class="field-list simple">
<dt class="field-odd">Options<span class="colon">:</span></dt>
<dd class="field-odd"><p>bool | int | float | str</p>
</dd>
</dl>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-reduce-d">
<span id="cmdoption-birdshot-reduce-default"></span><span class="sig-name descname"><span class="pre">-d</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--default</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;default&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-reduce-d" title="Link to this definition">¶</a></dt>
<dd><p>The default value to use if the cast fails. Default: None.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-reduce-f">
<span id="cmdoption-birdshot-reduce-func"></span><span class="sig-name descname"><span class="pre">-f</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--func</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;func&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-reduce-f" title="Link to this definition">¶</a></dt>
<dd><p>Specify a reduction to perform.</p>
<dl class="field-list simple">
<dt class="field-odd">Options<span class="colon">:</span></dt>
<dd class="field-odd"><p>central-tendency | mean | median | mode | std | variance | iqr</p>
</dd>
</dl>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-reduce-include">
<span class="sig-name descname"><span class="pre">--include</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;include&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-reduce-include" title="Link to this definition">¶</a></dt>
<dd><p>Regular expression describing properties that should be included.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-reduce-exclude">
<span class="sig-name descname"><span class="pre">--exclude</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;exclude&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-reduce-exclude" title="Link to this definition">¶</a></dt>
<dd><p>Regular expression describing properties that should be excluded.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-reduce-r">
<span id="cmdoption-birdshot-reduce-replace"></span><span class="sig-name descname"><span class="pre">-r</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--replace</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-reduce-r" title="Link to this definition">¶</a></dt>
<dd><p>Replace all properties with results from the reduction.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-reduce-suffix">
<span id="cmdoption-birdshot-reduce-no-suffix"></span><span class="sig-name descname"><span class="pre">--suffix</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--no-suffix</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-reduce-suffix" title="Link to this definition">¶</a></dt>
<dd><p>Whether to include a function-specific suffix to the set of properties. By default, if a suffix is provided then all properties with that suffix are skipped to avoid applying the reduction multiple times. Expressly specifying ‘–exclude’ will supercede this behavior.</p>
<dl class="field-list simple">
<dt class="field-odd">Default<span class="colon">:</span></dt>
<dd class="field-odd"><p><code class="docutils literal notranslate"><span class="pre">True</span></code></p>
</dd>
</dl>
</dd></dl>

</section>
<section id="birdshot-replace">
<h2>replace<a class="headerlink" href="#birdshot-replace" title="Link to this heading">¶</a></h2>
<p>Replace all occurances of &lt;OLD&gt; with &lt;NEW&gt;.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>replace<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span><span class="w"> </span>OLD<span class="w"> </span>NEW
</pre></div>
</div>
<p class="rubric">Arguments</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-replace-arg-OLD">
<span class="sig-name descname"><span class="pre">OLD</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-replace-arg-OLD" title="Link to this definition">¶</a></dt>
<dd><p>Required argument</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-replace-arg-NEW">
<span class="sig-name descname"><span class="pre">NEW</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-replace-arg-NEW" title="Link to this definition">¶</a></dt>
<dd><p>Required argument</p>
</dd></dl>

</section>
<section id="birdshot-store">
<h2>store<a class="headerlink" href="#birdshot-store" title="Link to this heading">¶</a></h2>
<p>Store the arguments for future, keyed access.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>store<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-store-k">
<span id="cmdoption-birdshot-store-key"></span><span class="sig-name descname"><span class="pre">-k</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--key</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;key&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-store-k" title="Link to this definition">¶</a></dt>
<dd><p><strong>Required</strong> Store the current stream.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-store-squeeze">
<span class="sig-name descname"><span class="pre">--squeeze</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-store-squeeze" title="Link to this definition">¶</a></dt>
<dd><p>If only one element is in the stream, store the element not a list.</p>
</dd></dl>

</section>
<section id="birdshot-str">
<h2>str<a class="headerlink" href="#birdshot-str" title="Link to this heading">¶</a></h2>
<p>Cast each object as a string.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>str<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-strip">
<h2>strip<a class="headerlink" href="#birdshot-strip" title="Link to this heading">¶</a></h2>
<p>Strips the chars from the front and back of strings.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>strip<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span><span class="w"> </span>CHARS
</pre></div>
</div>
<p class="rubric">Arguments</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-strip-arg-CHARS">
<span class="sig-name descname"><span class="pre">CHARS</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-strip-arg-CHARS" title="Link to this definition">¶</a></dt>
<dd><p>Required argument</p>
</dd></dl>

</section>
<section id="birdshot-tabulate">
<h2>tabulate<a class="headerlink" href="#birdshot-tabulate" title="Link to this heading">¶</a></h2>
<p>Converts a graph to a DataFrame. This consumes all objects in the stream.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>tabulate<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-tabulate-g">
<span id="cmdoption-birdshot-tabulate-graph"></span><span class="sig-name descname"><span class="pre">-g</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--graph</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;graph&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-tabulate-g" title="Link to this definition">¶</a></dt>
<dd><p>Key to access the previously stored graph.</p>
</dd></dl>

</section>
<section id="birdshot-to-csv">
<h2>to-csv<a class="headerlink" href="#birdshot-to-csv" title="Link to this heading">¶</a></h2>
<p>Write all dataframes and graphs/nodes to CSV.</p>
<section id="parameters">
<h3>Parameters<a class="headerlink" href="#parameters" title="Link to this heading">¶</a></h3>
<div class="line-block">
<div class="line">sep : str, default ‘,’</div>
<div class="line-block">
<div class="line">String of length 1. Field delimiter for the output file.</div>
</div>
<div class="line">na_rep : str, default ‘’</div>
<div class="line-block">
<div class="line">Missing data representation.</div>
</div>
<div class="line">float_format : str, Callable, default None</div>
<div class="line-block">
<div class="line">Format string for floating point numbers. If a Callable is given, it takes</div>
<div class="line">precedence over other numeric formatting parameters, like decimal.</div>
</div>
<div class="line">columns : sequence, optional</div>
<div class="line-block">
<div class="line">Columns to write.</div>
</div>
<div class="line">header : bool or list of str, default True</div>
<div class="line-block">
<div class="line">Write out the column names. If a list of strings is given it is</div>
<div class="line">assumed to be aliases for the column names.</div>
</div>
<div class="line">index : bool, default True</div>
<div class="line-block">
<div class="line">Write row names (index).</div>
</div>
<div class="line">index_label : str or sequence, or False, default None</div>
<div class="line-block">
<div class="line">Column label for index column(s) if desired. If None is given, and</div>
<div class="line"><cite>header</cite> and <cite>index</cite> are True, then the index names are used. A</div>
<div class="line">sequence should be given if the object uses MultiIndex. If</div>
<div class="line">False do not print fields for index names. Use index_label=False</div>
<div class="line">for easier importing in R.</div>
</div>
<div class="line">mode : {‘w’, ‘x’, ‘a’}, default ‘w’</div>
<div class="line-block">
<div class="line">Forwarded to either <cite>open(mode=)</cite> or <cite>fsspec.open(mode=)</cite> to control</div>
<div class="line">the file opening. Typical values include:</div>
</div>
</div>
<blockquote>
<div><blockquote>
<div><ul class="simple">
<li><p>‘w’, truncate the file first.</p></li>
<li><p>‘x’, exclusive creation, failing if the file already exists.</p></li>
<li><p>‘a’, append to the end of file if it exists.</p></li>
</ul>
</div></blockquote>
<dl>
<dt>encoding<span class="classifier">str, optional</span></dt><dd><p>A string representing the encoding to use in the output file,
defaults to ‘utf-8’. <cite>encoding</cite> is not supported if <cite>path_or_buf</cite>
is a non-binary file object.</p>
</dd>
<dt>compression<span class="classifier">str or dict, default ‘infer’</span></dt><dd><p>For on-the-fly compression of the output data. If ‘infer’ and ‘path_or_buf’ is
path-like, then detect compression from the following extensions: ‘.gz’,
‘.bz2’, ‘.zip’, ‘.xz’, ‘.zst’, ‘.tar’, ‘.tar.gz’, ‘.tar.xz’ or ‘.tar.bz2’
(otherwise no compression).
Set to <code class="docutils literal notranslate"><span class="pre">None</span></code> for no compression.
Can also be a dict with key <code class="docutils literal notranslate"><span class="pre">'method'</span></code> set
to one of {<code class="docutils literal notranslate"><span class="pre">'zip'</span></code>, <code class="docutils literal notranslate"><span class="pre">'gzip'</span></code>, <code class="docutils literal notranslate"><span class="pre">'bz2'</span></code>, <code class="docutils literal notranslate"><span class="pre">'zstd'</span></code>, <code class="docutils literal notranslate"><span class="pre">'xz'</span></code>, <code class="docutils literal notranslate"><span class="pre">'tar'</span></code>} and
other key-value pairs are forwarded to
<code class="docutils literal notranslate"><span class="pre">zipfile.ZipFile</span></code>, <code class="docutils literal notranslate"><span class="pre">gzip.GzipFile</span></code>,
<code class="docutils literal notranslate"><span class="pre">bz2.BZ2File</span></code>, <code class="docutils literal notranslate"><span class="pre">zstandard.ZstdCompressor</span></code>, <code class="docutils literal notranslate"><span class="pre">lzma.LZMAFile</span></code> or
<code class="docutils literal notranslate"><span class="pre">tarfile.TarFile</span></code>, respectively.
As an example, the following could be passed for faster compression and to create
a reproducible gzip archive:
<code class="docutils literal notranslate"><span class="pre">compression={'method':</span> <span class="pre">'gzip',</span> <span class="pre">'compresslevel':</span> <span class="pre">1,</span> <span class="pre">'mtime':</span> <span class="pre">1}</span></code>.</p>
<div class="versionadded">
<p><span class="versionmodified added">New in version 1.5.0: </span>Added support for <cite>.tar</cite> files.</p>
</div>
<p>May be a dict with key ‘method’ as compression mode
and other entries as additional compression options if
compression mode is ‘zip’.</p>
<p>Passing compression options as keys in dict is
supported for compression modes ‘gzip’, ‘bz2’, ‘zstd’, and ‘zip’.</p>
<div class="versionchanged">
<p><span class="versionmodified changed">Changed in version 1.2.0: </span>Compression is supported for binary file objects.</p>
</div>
<div class="versionchanged">
<p><span class="versionmodified changed">Changed in version 1.2.0: </span>Previous versions forwarded dict entries for ‘gzip’ to
<cite>gzip.open</cite> instead of <cite>gzip.GzipFile</cite> which prevented
setting <cite>mtime</cite>.</p>
</div>
</dd>
<dt>quoting<span class="classifier">optional constant from csv module</span></dt><dd><p>Defaults to csv.QUOTE_MINIMAL. If you have set a <cite>float_format</cite>
then floats are converted to strings and thus csv.QUOTE_NONNUMERIC
will treat them as non-numeric.</p>
</dd>
<dt>quotechar<span class="classifier">str, default ‘”’</span></dt><dd><p>String of length 1. Character used to quote fields.</p>
</dd>
<dt>lineterminator<span class="classifier">str, optional</span></dt><dd><p>The newline character or character sequence to use in the output
file. Defaults to <cite>os.linesep</cite>, which depends on the OS in which
this method is called (’n’ for linux, ‘rn’ for Windows, i.e.).</p>
<div class="versionchanged">
<p><span class="versionmodified changed">Changed in version 1.5.0: </span>Previously was line_terminator, changed for consistency with
read_csv and the standard library ‘csv’ module.</p>
</div>
</dd>
<dt>chunksize<span class="classifier">int or None</span></dt><dd><p>Rows to write at a time.</p>
</dd>
<dt>date_format<span class="classifier">str, default None</span></dt><dd><p>Format string for datetime objects.</p>
</dd>
<dt>doublequote<span class="classifier">bool, default True</span></dt><dd><p>Control quoting of <cite>quotechar</cite> inside a field.</p>
</dd>
<dt>escapechar<span class="classifier">str, default None</span></dt><dd><p>String of length 1. Character used to escape <cite>sep</cite> and <cite>quotechar</cite>
when appropriate.</p>
</dd>
<dt>decimal<span class="classifier">str, default ‘.’</span></dt><dd><p>Character recognized as decimal separator. E.g. use ‘,’ for
European data.</p>
</dd>
<dt>errors<span class="classifier">str, default ‘strict’</span></dt><dd><p>Specifies how encoding and decoding errors are to be handled.
See the errors argument for <a class="reference external" href="https://docs.python.org/3.11/library/functions.html#open" title="(in Python v3.11)"><code class="xref py py-func docutils literal notranslate"><span class="pre">open()</span></code></a> for a full list
of options.</p>
</dd>
<dt>storage_options<span class="classifier">dict, optional</span></dt><dd><p>Extra options that make sense for a particular storage connection, e.g.
host, port, username, password, etc. For HTTP(S) URLs the key-value pairs
are forwarded to <code class="docutils literal notranslate"><span class="pre">urllib.request.Request</span></code> as header options. For other
URLs (e.g. starting with “s3://”, and “gcs://”) the key-value pairs are
forwarded to <code class="docutils literal notranslate"><span class="pre">fsspec.open</span></code>. Please see <code class="docutils literal notranslate"><span class="pre">fsspec</span></code> and <code class="docutils literal notranslate"><span class="pre">urllib</span></code> for more
details, and for more examples on storage options refer <a class="reference external" href="https://pandas.pydata.org/docs/user_guide/io.html?highlight=storage_options#reading-writing-remote-files">here</a>.</p>
<div class="versionadded">
<p><span class="versionmodified added">New in version 1.2.0.</span></p>
</div>
</dd>
</dl>
</div></blockquote>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>to-csv<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span><span class="w"> </span>FILENAME
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-to-csv-g">
<span id="cmdoption-birdshot-to-csv-graph"></span><span class="sig-name descname"><span class="pre">-g</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--graph</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;graph&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-to-csv-g" title="Link to this definition">¶</a></dt>
<dd><p>Stored graph to use when determining the node path/indexes.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-to-csv-p">
<span id="cmdoption-birdshot-to-csv-params"></span><span class="sig-name descname"><span class="pre">-p</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--params</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;params&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-to-csv-p" title="Link to this definition">¶</a></dt>
<dd><p>Additional parameters to control CSV writer.</p>
</dd></dl>

<p class="rubric">Arguments</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-to-csv-arg-FILENAME">
<span class="sig-name descname"><span class="pre">FILENAME</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-to-csv-arg-FILENAME" title="Link to this definition">¶</a></dt>
<dd><p>Required argument</p>
</dd></dl>

</section>
</section>
<section id="birdshot-unpack">
<h2>unpack<a class="headerlink" href="#birdshot-unpack" title="Link to this heading">¶</a></h2>
<p>Load contents from the backend data store as node properties.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>unpack<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
</section>
<section id="birdshot-where">
<h2>where<a class="headerlink" href="#birdshot-where" title="Link to this heading">¶</a></h2>
<p>Select objects masked by the variable in “store” or the stack. By default
the last entry in the stack is used. The shorter of mask and stream
dictates the length of the output.</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>birdshot<span class="w"> </span>where<span class="w"> </span><span class="o">[</span>OPTIONS<span class="o">]</span>
</pre></div>
</div>
<p class="rubric">Options</p>
<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-where-s">
<span id="cmdoption-birdshot-where-store"></span><span class="sig-name descname"><span class="pre">-s</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--store</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;store&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-where-s" title="Link to this definition">¶</a></dt>
<dd><p>Retrieve the mask (objects must be castable to boolean) from a store variable.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-where-i">
<span id="cmdoption-birdshot-where-index"></span><span class="sig-name descname"><span class="pre">-i</span></span><span class="sig-prename descclassname"></span><span class="sig-prename descclassname"><span class="pre">,</span> </span><span class="sig-name descname"><span class="pre">--index</span></span><span class="sig-prename descclassname"> <span class="pre">&lt;index&gt;</span></span><a class="headerlink" href="#cmdoption-birdshot-where-i" title="Link to this definition">¶</a></dt>
<dd><p>Retrieve the mask (objects must be castable to boolean) from the stack. Default: last stack entry.</p>
</dd></dl>

<dl class="std option">
<dt class="sig sig-object std" id="cmdoption-birdshot-where-push">
<span class="sig-name descname"><span class="pre">--push</span></span><span class="sig-prename descclassname"></span><a class="headerlink" href="#cmdoption-birdshot-where-push" title="Link to this definition">¶</a></dt>
<dd><p>Push the mask back into the stack after extraction.</p>
</dd></dl>

</section>
</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">birdshot</a></h1>








<h3>Navigation</h3>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="readme.html">Overview</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">CLI</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-aggregate">aggregate</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-all">all</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-any">any</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-apply">apply</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-bool">bool</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-children">children</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-dict">dict</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-download">download</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-drop">drop</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-dump">dump</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-dumps">dumps</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-field">field</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-get">get</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-graph">graph</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-iter">iter</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-len">len</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-list">list</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-load">load</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-model-dump">model-dump</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-node-filter">node-filter</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-nodes">nodes</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-parents">parents</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-path">path</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-pop">pop</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-propagate">propagate</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-push">push</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-reduce">reduce</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-replace">replace</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-store">store</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-str">str</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-strip">strip</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-tabulate">tabulate</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-to-csv">to-csv</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-unpack">unpack</a></li>
<li class="toctree-l2"><a class="reference internal" href="#birdshot-where">where</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="changelog.html">Changelog</a></li>
<li class="toctree-l1"><a class="reference internal" href="api/modules.html">Module Reference</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
      <li>Previous: <a href="readme.html" title="previous chapter">birdshot</a></li>
      <li>Next: <a href="contributing.html" title="next chapter">Contributing</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Contextualize LLC.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
      |
      <a href="_sources/cli.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>